/*
Copyright 2022 The OpenYurt Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

package yurttest

import (
	"errors"

	"github.com/spf13/cobra"

	"github.com/openyurtio/openyurt/pkg/yurtctl/cmd/yurttest/kindinit"
)

func NewCmdTest() *cobra.Command {
	cmd := &cobra.Command{
		Use:   "test",
		Short: "Tools for developers to test the OpenYurt Cluster",
		RunE: func(cmd *cobra.Command, args []string) error {
			err := cmd.Help()
			if err != nil {
				return err
			}
			return errors.New("subcommand is required")
		},
		Args: cobra.NoArgs,
	}

	cmd.AddCommand(kindinit.NewKindInitCMD())

	return cmd
}
